
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Nginx+Keepalived(双机热备)搭建高可用负载均衡环境(HA) / iVAN</title>

    <meta name="description" content="Nginx+Keepalived(双机热备)搭建高可用负载均衡环境(HA) 基于 Nginx+Tomcat+Redis负载均衡Session共享来实现后续的功能 个人微信小程序.是关于人工智能的.应用是百度大脑 和 腾讯优图的人脸识别 有问题加QQ:783021975 验证问题写明在哪知道的QQ.直接说问的问题.会在不忙的时候回复你.毕竟我也有自己的工作要做. 一张简单的图说下大概的意思 安装Keepalived到CentOS虚拟机环境(2个虚拟机都安装) 使用的版本为keepalived-1.2.24.tar.gz 为了方便安装,在系统里面提前下载好相关的库 yum">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Nginx+Keepalived(双机热备)搭建高可用负载均衡环境(HA)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>基于 Nginx+Tomcat+Redis负载均衡Session共享来实现后续的功能</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzdmNmRiM2IyZTA1YTY5ZjYyN2U0ODJjZGNiMWJjZGI4NjIwNjA2NDIucG5n.jpg"><br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2YwOWQ3NzM0OGNkYjU5ZDU2MWVkMjlkYmMxZTBlZDc1MWFlYTI1MDEucG5n.jpg"></p>
<p>个人微信小程序。是关于人工智能的。应用是百度大脑 和 腾讯优图的人脸识别</p>
<p>有问题加QQ：783021975 验证问题写明在哪知道的QQ。直接说问的问题。会在不忙的时候回复你。毕竟我也有自己的工作要做。</p>
<p>一张简单的图说下大概的意思</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzZiMWRmYjIyY2I1ZTIxM2Q3NTUxMDAzZjJhOTM0ODY5ZThkMmI1MzgucG5n.jpg"></p>
<p>安装Keepalived到CentOS虚拟机环境(2个虚拟机都安装)</p>
<p>使用的版本为keepalived-1.2.24.tar.gz 为了方便安装，在系统里面提前下载好相关的库</p>
<pre><code>yum -y install libnl libnl-devel
yum install -y libnfnetlink-devel
</code></pre>
<p>然后就开始解压编译安装吧</p>
<pre><code>tar -zxvf  keepalived-1.2.24.tar.gz
cd  keepalived-1.2.24.tar.gz
./configure --prefix=/usr/local/keepalived
make
make install
然后继续配置Keepalived

mkdir /etc/keepalived
cp /usr/local/keepalived/etc/keepalived.conf /etc/keepalived/keepalived.conf
cp /usr/local/keepalived/etc/rc.d/init.d/keepalived /etc/rc.d/init.d/keepalived
cp /usr/local/keepalived/etc/sysconfig/keepalived /etc/sysconfig/keepalived
添加到开机自启
chkconfig keepalived on

如果提示keepalived: command not found 解决方法如下
ln -s /usr/local/keepalived/sbin/keepalived /sbin/
如果遇权限不足 执行以下命令
chmod 755 /etc/init.d/keepalived

相关操作
service keepalived start   #启动服务
service keepalived stop    #停止服务
service keepalived restart #重启服务
</code></pre>
<p>请不要着急去启动Keepalived<br />Keepalived的配置文件说明</p>
<p>引用于<a href="http://blog.csdn.net/xyang81/article/details/52554398" rel="external nofollow noreferrer">http://blog.csdn.net/xyang81/article/details/52554398</a><br />keepalived服务安装完成之后，后面的主要工作就是在keepalived.conf文件中配置HA和负载均衡。<br />一个功能比较完整的常用的keepalived配置文件，主要包含三块：<br />全局定义块、VRRP实例定义块和虚拟服务器定义块。<br />全局定义块是必须的，如果keepalived只用来做ha，<br />虚拟服务器是可选的。下面是一个功能比较完整的配置文件模板：</p>
<h1>全局定义块</h1>
<pre><code>global_defs {
    # 邮件通知配置
    notification_email {
        email1
        email2
    }
    notification_email_from email
    smtp_server host
    smtp_connect_timeout num

    lvs_id string
    router_id string    ## 标识本节点的字条串,通常为hostname
}

#VRRP 实例定义块
vrrp_sync_group string {
    group {
        string
        string
    }
}

vrrp_instance string {
    state MASTER|BACKUP
    virtual_router_id num
    interface string
    mcast_src_ip @IP
    priority num
    advert_int num
    nopreempt
    smtp_alert
    lvs_sync_daemon_interface string
    authentication {
        auth_type PASS|AH
        auth_pass string
    }

    virtual_ipaddress {  # Block limited to 20 IP addresses @IP
        @IP
        @IP
    }
}

#虚拟服务器定义块
virtual_server (@IP PORT)|(fwmark num) {
    delay_loop num
    lb_algo rr|wrr|lc|wlc|sh|dh|lblc
    lb_kind NAT|DR|TUN
    persistence_timeout num
    protocol TCP|UDP
    real_server @IP PORT {
        weight num
        notify_down /path/script.sh
        TCP_CHECK {
            connect_port num
            connect_timeout num
        }
    }

    real_server @IP PORT {
        weight num
        MISC_CHECK {
            misc_path /path_to_script/script.sh(or misc_path “/path_to_script/script.sh &lt;arg_list&gt;”)
        }
    }

    real_server @IP PORT {
        weight num
        HTTP_GET|SSL_GET {
            url {
                # You can add multiple url block path alphanum
                digest alphanum
            }
            connect_port num
            connect_timeout num
            nb_get_retry num
            delay_before_retry num
        }
    }
}
</code></pre>
<p>全局定义块</p>
<p>1、email通知（notification_email、smtp_server、smtp_connect_timeout）：<br />用于服务有故障时发送邮件报警，可选项，不建议用。需要系统开启sendmail服务，<br />建议用第三独立监控服务，如用nagios全面监控代替。<br />2、lvs_id：lvs负载均衡器标识，在一个网络内，它的值应该是唯一的。<br />3、router_id：用户标识本节点的名称，通常为hostname<br />4、花括号｛｝：用来分隔定义块，必须成对出现。如果写漏了，<br />keepalived运行时不会得到预期的结果。由于定义块存在嵌套关系，<br />因此很容易遗漏结尾处的花括号，这点需要特别注意。<br />VRRP实例定义块</p>
<pre><code>vrrp_sync_group：同步vrrp级，用于确定失败切换（FailOver）包含的路由实例个数。</code></pre>
<p>即在有2个负载均衡器的场景，一旦某个负载均衡器失效，需要自动切换到另外一个负载均衡器的实例是哪</p>
<pre><code>group：至少要包含一个vrrp实例，vrrp实例名称必须和vrrp_instance定义的一致
vrrp_instance：vrrp实例名
1&gt; state：实例状态，只有MASTER 和 BACKUP两种状态，并且需要全部大写。</code></pre>
<p>抢占模式下，其中MASTER为工作状态，BACKUP为备用状态。当MASTER所在的服务器失效时，<br />BACKUP所在的服务会自动把它的状态由BACKUP切换到MASTER状态。<br />当失效的MASTER所在的服务恢复时，BACKUP从MASTER恢复到BACKUP状态。</p>
<pre><code>2&gt; interface：对外提供服务的网卡接口，即VIP绑定的网卡接口。</code></pre>
<p>如：eth0，eth1。当前主流的服务器都有2个或2个以上的接口（分别对应外网和内网），在选择网卡接口时，一定要核实清楚。</p>
<pre><code>3&gt; mcast_src_ip：本机IP地址
4&gt; virtual_router_id：虚拟路由的ID号，每个节点设置必须一样，</code></pre>
<p>可选择IP最后一段使用，相同的 VRID 为一个组，他将决定多播的 MAC 地址。</p>
<pre><code>5&gt; priority：节点优先级，取值范围0～254，MASTER要比BACKUP高
6&gt; advert_int：MASTER与BACKUP节点间同步检查的时间间隔，单位为秒
7&gt; lvs_sync_daemon_inteface：负载均衡器之间的监控接口,</code></pre>
<p>类似于 HA HeartBeat 的心跳线。但它的机制优于 Heartbeat，因为它没有“裂脑”这个问题,<br />它是以优先级这个机制来规避这个麻烦的。在 DR 模式中，<br />lvs_sync_daemon_inteface与服务接口interface使用同一个网络接口</p>
<pre><code>8&gt; authentication：验证类型和验证密码。类型主要有 PASS、AH 两种，通常使用PASS类型，</code></pre>
<p>据说AH使用时有问题。验证密码为明文，同一vrrp 实例MASTER与BACKUP使用相同的密码才能正常通信。</p>
<pre><code>9&gt; smtp_alert：有故障时是否激活邮件通知
10&gt; nopreempt：禁止抢占服务。默认情况，当MASTER服务挂掉之后，</code></pre>
<p>BACKUP自动升级为MASTER并接替它的任务，当MASTER服务恢复后，<br />升级为MASTER的BACKUP服务又自动降为BACKUP，<br />把工作权交给原MASTER。当配置了nopreempt，<br />MASTER从挂掉到恢复，不再将服务抢占过来。</p>
<pre><code>11&gt; virtual_ipaddress：虚拟IP地址池，可以有多个IP，每个IP占一行，不需要指定子网掩码。注意：这个IP必须与我们的设定的vip保持一致。
</code></pre>
<p>虚拟服务器virtual_server定义块</p>
<pre><code>virtual_server：定义一个虚拟服务器，这个ip是virtual_ipaddress中定义的其中一个，后面一个空格，然后加上虚拟服务的端口号。
1&gt; delay_loop：健康检查时间间隔，单位：秒
2&gt; lb_algo：负载均衡调度算法，互联网应用常用方式为wlc或rr
3&gt; lb_kind：负载均衡转发规则。包括DR、NAT、TUN 3种，一般使用路由（DR）转发规则。
4&gt; persistence_timeout：http服务会话保持时间，单位：秒
5&gt; protocol：转发协议，分为TCP和UDP两种
real_server：真实服务器IP和端口，可以定义多个
1&gt; weight：负载权重，值越大，转发的优先级越高
2&gt; notify_down：服务停止后执行的脚本
3&gt; TCP_CHECK：服务有效性检测
* connect_port：服务连接端口
* connect_timeout：服务连接超时时长，单位：秒
* nb_get_retry：服务连接失败重试次数
* delay_before_retry：重试连接间隔，单位：秒</code></pre>
<p>Keepalived+Nginx配置实现高可用负载均衡</p>
<p>服务器IP配置信息</p>
<pre><code>VIP(虚拟IP)    IP    主机名    Nginx端口
192.168.110.138    192.168.110.128    nginx_master    80
192.168.110.138    192.168.110.130    nginx_backup    80
</code></pre>
<p>Nginx安装上个博文中有给出</p>
<p>配置Keepalived(抢占模式配置) 增加VIP 启动服务</p>
<p>MASTER（192.168.110.128）配置信息</p>
<pre><code>global_defs {
   router_id nginx_master #hostname
}
vrrp_script chk_nginx {
    script "/etc/keepalived/nginx_check.sh" #检测nginx的脚本
    interval 2                              #每2秒检测一次
    weight -20                                #如果某一个nginx宕机 则权重减20
}
vrrp_instance VI_1 {
    state MASTER                            #状态 MASTER BACKUP
    interface eth0                            #绑定的网卡
    virtual_router_id 51                    #虚拟路由的ID号,两个节点设置必须一样
    mcast_src_ip 192.168.110.128            #本机的IP
    priority 90
    advert_int 1
# 设置验证信息，两个节点必须一致
    authentication {
        auth_type PASS
        auth_pass 1111
    }
 # 虚拟IP，两个节点设置必须一样。
    virtual_ipaddress {
        192.168.110.138
    }
# nginx存活状态检测脚本
    track_script {
       chk_nginx
    }
}
BACKUP（192.168.110.130）配置信息

global_defs {
   router_id nginx_backup  #hostname
}
vrrp_script chk_nginx {
    script "/etc/keepalived/nginx_check.sh" #检测nginx的脚本
    interval 2                              #每2秒检测一次
    weight -20                                #如果某一个nginx宕机 则权重减20
}
vrrp_instance VI_1 {
    state BACKUP                            #状态 MASTER BACKUP
    interface eth0                            #绑定的网卡
    virtual_router_id 51
    mcast_src_ip 192.168.110.130
    priority 90
    advert_int 1
    authentication {
        auth_type PASS
        auth_pass 1111
    }
    virtual_ipaddress {
        192.168.110.138
    }

    track_script {
       chk_nginx
    }
}
创建Nginx服务检测脚本

原文地址http://blog.csdn.net/xyang81/article/details/52556886
#!/bin/bash
A=`ps -C nginx --no-header | wc -l`
if [ $A -eq 0 ];then
    /opt/nginx/sbin/nginx #尝试重新启动nginx
    sleep 2  #睡眠2秒
    if [ `ps -C nginx --no-header | wc -l` -eq 0 ];then
        killall keepalived #启动失败，将keepalived服务杀死。将vip漂移到其它备份节点
    fi
fi
</code></pre>
<p>启动Keepalived服务 service keepalived start 看是否在MASTER绑定了VIP地址</p>
<p>MASTER 信息 (可以看到虚拟IP 192.168.110.138绑定在了MASTER服务器上面)</p>
<p>BACKUP信息</p>
<p>手动关闭MASTER模拟主服务器宕机，再看网络信息</p>
<p>MASTER 信息 (看到虚拟IP已经不存在 证明已经转移目标主机)</p>
<p>BACKUP信息(虚拟IP 192.168.110.138已经转移到BACKUP服务器)</p>
<p>查看项目是否正常，Session是否共享</p>
<p>使用是虚拟IP进行访问 登录没错</p>
<p>轮询Tomcat服务器也没有重新登录</p>
<p>Redis也是一个唯一的Session</p>
<p>结束语：</p>
<p>所有的测试都只是使用单项目进行入门测试。并不是多项目的测试。最入门的没有任何难度和相关指定参数的配置。如果要切合自己的业务去做。那就要仔细看配置文件说明了。只是学习这些技术的一个入门手段而已。不适合商业项目应用，具体根据实际业务来。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:07:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e8%b4%9f%e8%bd%bd%e5%9d%87%e8%a1%a1/" title="负载均衡">负载均衡</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e5%8f%af%e7%94%a8/" title="高可用">高可用</a>, <a href="https://www.iamivan.net/tag/nginx/" title="nginx">nginx</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Nginx+Keepalived(双机热备)搭建高可用负载均衡环境(HA)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2W9DvM.html" rel="bookmark">haproxy&plus;keepalived实现高可用负载均衡&lpar;理论篇&rpar;&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HAProxy相比LVS的使用要简单很多,功能方面也很丰富.当 前,HAProxy支持两种主要的代理模式:&quot;tcp&quot;也即4层(大多用于邮件服务器.内部协议通信服务器等),和7层(HTTP).在4层模式 下,HAProxy仅在客户端和服务器之间转发双向流量.7层模式下,HAProxy会分析协议,并且能通过允许.拒绝.交换.增加.修改或者删除请求 (request)或者回应(response)里指定内容来控制协议,这种操作要基于特定规则. 我现在用HAProxy主要在于它有以下优点,这里我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeom8jM.html" rel="bookmark">CentOS6&period;4 LVS&plus;keepalived高可用负载均衡服务配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CentOS6.4 LVS+keepalived高可用负载均衡服务配置     一:测试环境信息 服务器DELL-R720 虚拟化 KVM 虚拟机4台: ipvs01,ipvs02,web01,web02 [root@KVM01~]# virsh list  Id    Name                           State ----------------------------------------------------  1     SN-web01         			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkmxkOb.html" rel="bookmark">Keepalived&plus;HAProxy实现MySQL高可用负载均衡的配置&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 Keepalived 由于在生产环境使用了mysqlcluster,需要实现高可用负载均衡,这里提供了keepalived+haproxy来实现.       keepalived主要功能是实现真实机器的故障隔离及负载均衡器间的失败切换.可在第3,4,5层交换.它通过VRRPv2(Virtual Router Redundancy Protocol) stack实现的.       Layer3:Keepalived会定期向服务器群中的服务器.发送一个ICMP的数据包(既我们平时用的Ping程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeK5l8M.html" rel="bookmark">RHEL 5&period;4下部署LVS&lpar;DR&rpar;&plus;keepalived实现高性能高可用负载均衡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:http://www.cnblogs.com/mchina/archive/2012/05/23/2514728.html 一.简介 LVS是Linux Virtual Server的简写,意即Linux虚拟服务器,是一个虚拟的服务器集群系统.本项目在1998年5月由章文嵩博士成立,是中国国内最早出现的自由软件项目之一. 目前有三种IP负载均衡技术(VS/NAT.VS/TUN和VS/DR):十种调度算法(rr|wrr|lc|wlc|lblc|lblcr|dh|sh|sed|nq). K			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91j1gM.html" rel="bookmark">LVS&plus;Keepalived构建高可用负载均衡的配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. LVS简介 LVS是Linux Virtual Server的简称,也就是Linux虚拟服务器, 是一个由 章文嵩博士发起的自由软件项目,它的官方站点是www.linuxvirtualserver.org .现在LVS已经是 Linux标准内核的一部分,在Linux2.4内核以前,使用LVS时必 须要重新编译内核以支持LVS功能模块,但是从Linux2.4内核以后,已经完全内置 了LVS的各个功能模块,无需给内核打任何补丁,可以直接使用LVS提供的各种功 能.使用LVS技术要达到的目标是:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7Q3mp.html" rel="bookmark">tengine &plus; tomcat 安装整合实现高可用负载均衡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先介绍下tengine Tengine是由淘宝网发起的Web服务器项目.它在Nginx的基础上,针对大访问量网站的需求,添加了很多高级功能和特性.Tengine的性能和稳定性已经在大型的网站如淘宝网,天猫商城等得到了很好的检验.它的最终目标是打造一个高效.稳定.安全.易用的Web平台. 好,在做之前呢,说下为什么要做这个东西 1.nginx反向代理不需要tomcat的IP是否为外网IP,只要nginx server能和tomcat进行通讯,安全的同时减少了不必要的外网ip 2.当tomcat宕掉			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Ogr0b.html" rel="bookmark">heartbeat&plus;lvs构建高可用负载均衡集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				heartbeat+lvs实现高可用负载均衡原理: 两台heartbeat(ldirectord)主机构成高可用集群,同时监管着lvs(负载均衡集群)整体构成了heartbeat+lvs的高可用负载均衡集群.在使用heartbeat的时候加载了watchdog模块,用来检测heartbeat服务,当heartbeat服务出现故障,会进行重启主机. 注意:但是,当内核崩溃了,watchdog也无能了(modprobe softdog),因为watchdog是基于内核级别的软件服务(相当于软fenc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ7O74b.html" rel="bookmark">LVS&plus;Keepalived构建高可用负载均衡的测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 启动LVS高可用集群服务 首先,启动每个real server节点的服务: [root@localhost ~]# /etc/init.d/lvsrs  start start LVS  of  REALServer 然后,分别在主备Director Server启动Keepalived服务: [root@DR1 ~]#/etc/init.d/Keepalived  start [root@DR1 ~]#/ ipvsadm -L IP Virtual Server version 1.2.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwXrgdb.html" rel="bookmark">LVS&plus;Keepalived构建高可用负载均衡&lpar;测试篇&rpar;&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 启动LVS高可用集群服务 首先,启动每个real server节点的服务: [root@localhost ~]# /etc/init.d/lvsrs start start LVS of REALServer 然后,分别在主备Director Server启动Keepalived服务: [root@DR1 ~]#/etc/init.d/Keepalived start [root@DR1 ~]#/ ipvsadm -L IP Virtual Server version 1.2.1 (s			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7kY5z.html" rel="bookmark" class="title">freopen重定向stdin与stdout后如何恢复正常</a>
					<div>
						函数定义如下: FILE * freopen ( const char * filename, const char * mode, FILE * stream ); 在windows下控制台的标准输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxBnyz.html" rel="bookmark" class="title">《统一沟通-微软-培训》-2-部署-反向代理-3-创建-访问规则</a>
					<div>
						&lt;统一沟通-微软-培训&gt;-2-部署-反向代理-3-创建-访问规则-intranet To internet All 使用新建访问规则向导创建访问规则-intranet To interne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2rg5p.html" rel="bookmark" class="title">谷歌面试题解析：n支队伍比赛，分别编号为0，1，2。。。。n-1</a>
					<div>
						题目: n支队伍比赛,分别编号为0,1,2....n-1,已知它们之间的实力对比关系,存储在一个二维数组w[n][n]中,w[i][j] 的值代表编号为i,j的队伍中更强的一支.所以w[i][j]=i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2Z2ab.html" rel="bookmark" class="title">Cassandra数据库中如何在opscenter中显示Performance Metrics 信息</a>
					<div>
						本来我们在(192.168.129.34,192.168.129.35,192.168.129.39 三机集群中正确的搭建了,但是在opscenter中一直收不到精确的系统统计信息: 我后来研究了下, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN1qDb.html" rel="bookmark" class="title">数据结构的C&plus;&plus;实现之队列的链式存储结构</a>
					<div>
						队列的链式存储结构,其实就是线性表的单链表,只不过它只能尾进头出而已,我们把它简称为链队列.为了操作上的 方便,我们将队头指针指向链队列的头节点,而队尾指针指向终端节点.空队列时,front和rear ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnEgmz.html" rel="bookmark" class="title">Cocos2D-X入门（15）实现拖尾效果</a>
					<div>
						游戏中的刀光剑影 好的游戏效果必不可少,cocos2D中用CCMotionStreak实现这样的拖尾效果. streak=CCMotionStreak::create(1, 16, 16, ccc3( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4jAwp.html" rel="bookmark" class="title">用java类中的映射获取变量名</a>
					<div>
						在类中定义了一个属性abc,如何获取这个变量的abc的名字串呢?也就是说怎么知道 abc这个变量的名字是abc,这个问题比较的好玩. 这个是偶在一开发中遇到的一个比较有趣的问题,找 了半天的资料加下偶 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M621vJM.html" rel="bookmark" class="title">css white-space&colon;nowrap属性用法</a>
					<div>
						 css强制文字不换行,可给指定的容器增加white-space:nowrap即,下面把CSS示例写给大家,很简单 强制不换行,直接使用white-space:nowrap即可. CSS设置不转行:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Ry38p.html" rel="bookmark" class="title">vba操作Excel之MsgBox函数参数详解</a>
					<div>
						一.函数语法 函数名称:MsgBox 函数功能:在对话框中显示消息,等待用户单击按钮,并返回一个 Integer 告诉用户单击哪一个按钮. 函数语法: MsgBox(prompt[, buttons] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlY4Eb.html" rel="bookmark" class="title">wps表格如何操作筛选格式&quest;</a>
					<div>
						  wps表格是我们办公时经常用的软件,为了方便平时的操作,wps表格中有很多操作技巧,下面来看看wps筛选格式,这个功能能够在整个表格中筛选出需要的内容.便于我们查询.便于我们操作. 软件名称: 金 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw8EBp.html" rel="bookmark" class="title">360安全桌面界面介绍</a>
					<div>
						  切换页面:鼠标滚动或者点击数字都可以实现流畅翻页. 右键功能:空白处点击右键可以管理应用,添加自定义分类,将本地已有的应用添加到桌面上,对安全桌面进行设置,退出全屏模式,反馈您对产品的意见以及查看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myw7avz.html" rel="bookmark" class="title">PHP连接MySql数据库</a>
					<div>
						&lt;?php // 数据库服务器IP或地址 $mysql_server_name='localhost';  // 数据库用户名 $mysql_username='demo';  // 数据库密码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNekKM.html" rel="bookmark" class="title">怎么在datagrid中添加一列combobox</a>
					<div>
						问题描述 代码:&lt;s:DataGridx=&quot;252&quot;y=&quot;103&quot;width=&quot;1046&quot;height=&quot;244&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3d84z.html" rel="bookmark" class="title">jdk 和tomcat安装没问题，部署项目时，tomcat起不来</a>
					<div>
						问题描述 jdk 和tomcat安装没问题,部署项目时,tomcat起不来 linux 系统用的myeclipse 在部署项目的时候tomcat起不来 jdk和tomcat安装没问题 解决方案 有报错 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxW6vb.html" rel="bookmark" class="title">域名解析的基本知识以及优缺点分析</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 域名解析是网站的必要组成部分,不过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7P12z.html" rel="bookmark" class="title">崔瀚文：人工智能&sol;机器人会不会成为人？取代人？</a>
					<div>
						文 | 崔瀚文 阿里研究院 当前人工智能/机器人快速发展,带来&quot;人类&quot;新的二律背反: 从消费角度而言,人的地位在机器的烘托和帮助下不断攀升,人类的尊严和价值似乎受到了前所未有尊崇, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pe64p.html" rel="bookmark" class="title">java 删除空行</a>
					<div>
						Java 中会经常处理字符串,需要删除其中的空行,而且要删除仅包含Tab.空格的空行. 范例如下: Java代码   @Test       public void deleteBlankLines4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL7wNp.html" rel="bookmark" class="title">基于C&num;&plus;ArcEngine9&period;3开发的SimpleGIS V3&period;0发布</a>
					<div>
						问题描述 SimpleGIS是基于C#+ArcEngine9.3环境开发的ArcEngine中间件产品,采用插件式开发机制,目前版本已更新至V3.0,在这个版本下,我们推出了土地定级模块和空间数据管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRmOZb.html" rel="bookmark" class="title">velocity-htm映射到ashx，运行时htm中图片能显示出来，ashx的就不能显示</a>
					<div>
						问题描述 htm映射到ashx,运行时htm中图片能显示出来,ashx的就不能显示 如图是htm的文件 如图是ashx的文件 如图是NVelocity中commonhelper的方法 到底是哪里出问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRm13b.html" rel="bookmark" class="title">&amp;amp&semi;amp&semi;&num;9733&semi;如何解释特修斯之船问题？</a>
					<div>
						如何解释特修斯之船问题?----来自知乎网友 一艘在海上航行了几百年的船,被不间断地维修和替换部件.只要一块木板腐烂了,它就会被替换掉,以此类推,直到所有的功能部件都不是最开始的那些了.问题是,最终产 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo2R7M.html" rel="bookmark" class="title">浏览器-Objective-C编写app中嵌入h5页面 geolocation定位问题</a>
					<div>
						问题描述 Objective-C编写app中嵌入h5页面 geolocation定位问题 我制作了一个用到geolocation定位的h5页面,让别人嵌到他开发的app中,用Safari浏览器时可以实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JRjkz.html" rel="bookmark" class="title">apache压力测试详细</a>
					<div>
						工具 AB(apache benchmark).在APACHE的bin目录下. 格式: ./ab [options] [http://]hostname[:port]/path 参数: -n requ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL4j8M.html" rel="bookmark" class="title">vb&period;net 获取打印机状态</a>
					<div>
						问题描述 求助高手!1.获取电脑是否有联机打印机,并将联机打印机设置为默认打印机(状态为&quot;就绪&quot;的打印机).2.获取打印机状态,如果缺纸.缺墨.卡纸点.3.可以初始化打印机一些参数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnKP8p.html" rel="bookmark" class="title">python中的多线程实例教程&lowbar;python</a>
					<div>
						本文以实例形式较为详细的讲述了Python中多线程的用法,在Python程序设计中有着比较广泛的应用.分享给大家供大家参考之用.具体分析如下: python中关于多线程的操作可以使用thread和th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn83Gkb.html" rel="bookmark" class="title">javaScript年份下拉列表框内容为当前年份及前后50年&lowbar;javascript技巧</a>
					<div>
						javascript下拉列表框,内容为当前年份及前后50年,默认选择为当前年份 复制代码 代码如下: &lt;script language=&quot;javascript&quot; type=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEn2Bz.html" rel="bookmark" class="title">vb&period;net中怎样向pictruebox控件上写汉字</a>
					<div>
						问题描述 PrivateDeclareFunctionGetDCLib&quot;user32&quot;(ByValhwndAsLong)AsLongPrivateDeclareFunctionTe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdGRAp.html" rel="bookmark" class="title">android-新手烦死了，经理给我一个service如下：如何在Android中实现登录的功能，希望有代码</a>
					<div>
						问题描述 新手烦死了,经理给我一个service如下:如何在Android中实现登录的功能,希望有代码 @WebService public class LoginServiceImpl implem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJn8qM.html" rel="bookmark" class="title">网友称没想到用户的反馈真的能传递到海尔集团的研发部门</a>
					<div>
						&quot;心心&quot;告诉记者,自己就职于上海某机关,工作之余,她非常关注生活时尚与家居品质.在她眼中,家电产品与生活息息相关,是营造舒适居家环境的关键,因而选购也十分挑剔.&quot;亲历卡萨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKJnZz.html" rel="bookmark" class="title">小心陌生人发信息窃取淘宝帐号和密码</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 今天可心姑收到淘宝旺旺上一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlWn0qb.html" rel="bookmark" class="title">Spring Bean的生命周期详细介绍&lowbar;java</a>
					<div>
						Spring作为当前Java最流行.最强大的轻量级框架,受到了程序员的热烈欢迎.准确的了解Spring Bean的生命周期是非常必要的.我们通常使用ApplicationContext作为Spring ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
